/*
 * LCD_Pins.c
 *
 *  Created on: Jan 13, 2024
 *      Author: hussamaldean
 */


#include "LCD_Pins.h"

#include "stm32f7xx.h"
#include "time_base.h"
/*Connection
 *
 * PF3 ->CS
 * PF5 ->DC
 * PF10 ->RST
 *
 * */



void LCD_Pins_Init(void)
{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOFEN;

	GPIOF->MODER|=GPIO_MODER_MODER3_0|GPIO_MODER_MODER5_0|GPIO_MODER_MODER10_0;
	GPIOF->MODER&=~(GPIO_MODER_MODER3_1|GPIO_MODER_MODER5_1|GPIO_MODER_MODER10_1);

	/*Set CS and RST to high*/
	GPIOF->BSRR=GPIO_BSRR_BS3|GPIO_BSRR_BS10;
}


void CS_LOW(void)
{
	GPIOF->BSRR=GPIO_BSRR_BR3;
}

void CS_HIGH(void)
{
	GPIOF->BSRR=GPIO_BSRR_BS3;
}

void DC_LOW (void)
{
	GPIOF->BSRR=GPIO_BSRR_BR5;
}

void DC_HIGH (void)
{
	GPIOF->BSRR=GPIO_BSRR_BS5;
}

void LCD_RST(void)
{
	GPIOF->BSRR=GPIO_BSRR_BR10;
	delay(100);
	GPIOF->BSRR=GPIO_BSRR_BS10;
	delay(10);

}
